/*
 * ConsoleEngCalculatorAboutBox.java
 */

package consoleengcalculator;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.LinkedList;
import java.util.Locale;

public class ConsoleEngCalculatorDrawOptions extends javax.swing.JDialog {
    private NumericInputVerifier numericInputVerifier = new NumericInputVerifier();
    private static DecimalFormat decimalFormat = new DecimalFormat ("######.##", new DecimalFormatSymbols (Locale.ENGLISH));

    public ConsoleEngCalculatorDrawOptions(java.awt.Frame parent) {
        super(parent);
        initComponents();
        getRootPane().setDefaultButton(jButtonCancel);
        jComboBoxAxesColor.setSelectedIndex(0);//black
        jComboBoxGridColor.setSelectedIndex(6);//light gray
        jComboBoxBackgroundColor.setSelectedIndex(11);//white
    }
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel4 = new javax.swing.JPanel();
        jPanelScale = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldXMin = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldXMax = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextFieldXTick = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextFieldYMax = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextFieldYTick = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldYMin = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jTextFieldCMin = new javax.swing.JTextField();
        jTextFieldCMax = new javax.swing.JTextField();
        jButtonOK = new javax.swing.JButton();
        jButtonFitZoom = new javax.swing.JButton();
        jButtonFitTick = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jPanelAxesColor = new javax.swing.JPanel();
        jComboBoxAxesColor = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jComboBoxGridColor = new javax.swing.JComboBox();
        jPanelGridColor = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jComboBoxBackgroundColor = new javax.swing.JComboBox();
        jPanelBackgroundColor = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jCheckBoxAxes = new javax.swing.JCheckBox();
        jCheckBoxGrid = new javax.swing.JCheckBox();
        jCheckBoxTickLabels = new javax.swing.JCheckBox();
        jCheckBoxDrawLabels = new javax.swing.JCheckBox();

        jPanel4.setName("jPanel4"); // NOI18N

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(consoleengcalculator.ConsoleEngCalculatorApp.class).getContext().getResourceMap(ConsoleEngCalculatorDrawOptions.class);
        setTitle(resourceMap.getString("title")); // NOI18N
        setName("Variable Shower"); // NOI18N
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });

        jPanelScale.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanelScale.border.title"))); // NOI18N
        jPanelScale.setName("jPanelScale"); // NOI18N

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        jTextFieldXMin.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldXMin.setText(resourceMap.getString("jTextFieldXMin.text")); // NOI18N
        jTextFieldXMin.setInputVerifier(numericInputVerifier);
        jTextFieldXMin.setName("jTextFieldXMin"); // NOI18N

        jLabel8.setText(resourceMap.getString("jLabel8.text")); // NOI18N
        jLabel8.setName("jLabel8"); // NOI18N

        jTextFieldXMax.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldXMax.setText(resourceMap.getString("jTextFieldXMax.text")); // NOI18N
        jTextFieldXMax.setInputVerifier(numericInputVerifier);
        jTextFieldXMax.setName("jTextFieldXMax"); // NOI18N

        jLabel11.setText(resourceMap.getString("jLabel11.text")); // NOI18N
        jLabel11.setName("jLabel11"); // NOI18N

        jTextFieldXTick.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldXTick.setText(resourceMap.getString("jTextFieldXTick.text")); // NOI18N
        jTextFieldXTick.setInputVerifier(numericInputVerifier);
        jTextFieldXTick.setName("jTextFieldXTick"); // NOI18N

        jLabel9.setText(resourceMap.getString("jLabel9.text")); // NOI18N
        jLabel9.setName("jLabel9"); // NOI18N

        jTextFieldYMax.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldYMax.setText(resourceMap.getString("jTextFieldYMax.text")); // NOI18N
        jTextFieldYMax.setInputVerifier(numericInputVerifier);
        jTextFieldYMax.setName("jTextFieldYMax"); // NOI18N

        jLabel10.setText(resourceMap.getString("jLabel10.text")); // NOI18N
        jLabel10.setName("jLabel10"); // NOI18N

        jTextFieldYTick.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldYTick.setText(resourceMap.getString("jTextFieldYTick.text")); // NOI18N
        jTextFieldYTick.setInputVerifier(numericInputVerifier);
        jTextFieldYTick.setName("jTextFieldYTick"); // NOI18N

        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        jTextFieldYMin.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldYMin.setText(resourceMap.getString("jTextFieldYMin.text")); // NOI18N
        jTextFieldYMin.setInputVerifier(numericInputVerifier);
        jTextFieldYMin.setName("jTextFieldYMin"); // NOI18N

        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N

        jLabel14.setText(resourceMap.getString("jLabel14.text")); // NOI18N
        jLabel14.setName("jLabel14"); // NOI18N

        jTextFieldCMin.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldCMin.setText(resourceMap.getString("jTextFieldCMin.text")); // NOI18N
        jTextFieldCMin.setInputVerifier(numericInputVerifier);
        jTextFieldCMin.setName("jTextFieldCMin"); // NOI18N

        jTextFieldCMax.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextFieldCMax.setText(resourceMap.getString("jTextFieldCMax.text")); // NOI18N
        jTextFieldCMax.setInputVerifier(numericInputVerifier);
        jTextFieldCMax.setName("jTextFieldCMax"); // NOI18N

        javax.swing.GroupLayout jPanelScaleLayout = new javax.swing.GroupLayout(jPanelScale);
        jPanelScale.setLayout(jPanelScaleLayout);
        jPanelScaleLayout.setHorizontalGroup(
            jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelScaleLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7)
                    .addComponent(jLabel13)
                    .addComponent(jLabel6)
                    .addComponent(jLabel11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextFieldXTick, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldCMin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldYMin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldXMin, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jLabel8)
                        .addComponent(jLabel9)
                        .addComponent(jLabel14))
                    .addComponent(jLabel10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextFieldYTick, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldYMax, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldXMax, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldCMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(18, Short.MAX_VALUE))
        );

        jPanelScaleLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextFieldCMax, jTextFieldCMin, jTextFieldXMax, jTextFieldXMin, jTextFieldXTick, jTextFieldYMax, jTextFieldYMin, jTextFieldYTick});

        jPanelScaleLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel10, jLabel11, jLabel13, jLabel14, jLabel6, jLabel7, jLabel8, jLabel9});

        jPanelScaleLayout.setVerticalGroup(
            jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelScaleLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanelScaleLayout.createSequentialGroup()
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextFieldXMin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldYMin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextFieldCMin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextFieldXTick, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanelScaleLayout.createSequentialGroup()
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldXMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldYMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldCMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelScaleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldYTick, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanelScaleLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jTextFieldCMax, jTextFieldCMin, jTextFieldXMax, jTextFieldXMin, jTextFieldXTick, jTextFieldYMax, jTextFieldYMin, jTextFieldYTick});

        jPanelScaleLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabel10, jLabel11, jLabel13, jLabel14, jLabel6, jLabel7, jLabel8, jLabel9});

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(consoleengcalculator.ConsoleEngCalculatorApp.class).getContext().getActionMap(ConsoleEngCalculatorDrawOptions.class, this);
        jButtonOK.setAction(actionMap.get("closeDrawBox")); // NOI18N
        jButtonOK.setText(resourceMap.getString("jButtonOK.text")); // NOI18N
        jButtonOK.setName("jButtonOK"); // NOI18N
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });

        jButtonFitZoom.setText(resourceMap.getString("jButtonFitZoom.text")); // NOI18N
        jButtonFitZoom.setName("jButtonFitZoom"); // NOI18N
        jButtonFitZoom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFitZoomActionPerformed(evt);
            }
        });

        jButtonFitTick.setText(resourceMap.getString("jButtonFitTick.text")); // NOI18N
        jButtonFitTick.setName("jButtonFitTick"); // NOI18N
        jButtonFitTick.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFitTickActionPerformed(evt);
            }
        });

        jButtonCancel.setAction(actionMap.get("closeDrawBox")); // NOI18N
        jButtonCancel.setText(resourceMap.getString("jButtonCancel.text")); // NOI18N
        jButtonCancel.setName("jButtonCancel"); // NOI18N
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel1.border.title"))); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        jPanelAxesColor.setBackground(resourceMap.getColor("jPanelAxesColor.background")); // NOI18N
        jPanelAxesColor.setName("jPanelAxesColor"); // NOI18N

        javax.swing.GroupLayout jPanelAxesColorLayout = new javax.swing.GroupLayout(jPanelAxesColor);
        jPanelAxesColor.setLayout(jPanelAxesColorLayout);
        jPanelAxesColorLayout.setHorizontalGroup(
            jPanelAxesColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 35, Short.MAX_VALUE)
        );
        jPanelAxesColorLayout.setVerticalGroup(
            jPanelAxesColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 27, Short.MAX_VALUE)
        );

        jComboBoxAxesColor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BLACK", "BLUE", "CYAN", "DARK_GRAY", "GRAY", "GREEN", "LIGHT_GRAY", "MAGENTA", "ORANGE", "PINK", "RED", "WHITE", "YELLOW" }));
        jComboBoxAxesColor.setName("jComboBoxAxesColor"); // NOI18N
        jComboBoxAxesColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxAxesColorActionPerformed(evt);
            }
        });

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        jComboBoxGridColor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BLACK", "BLUE", "CYAN", "DARK_GRAY", "GRAY", "GREEN", "LIGHT_GRAY", "MAGENTA", "ORANGE", "PINK", "RED", "WHITE", "YELLOW" }));
        jComboBoxGridColor.setName("jComboBoxGridColor"); // NOI18N
        jComboBoxGridColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxGridColorActionPerformed(evt);
            }
        });

        jPanelGridColor.setBackground(resourceMap.getColor("jPanelGridColor.background")); // NOI18N
        jPanelGridColor.setName("jPanelGridColor"); // NOI18N

        javax.swing.GroupLayout jPanelGridColorLayout = new javax.swing.GroupLayout(jPanelGridColor);
        jPanelGridColor.setLayout(jPanelGridColorLayout);
        jPanelGridColorLayout.setHorizontalGroup(
            jPanelGridColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 35, Short.MAX_VALUE)
        );
        jPanelGridColorLayout.setVerticalGroup(
            jPanelGridColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 27, Short.MAX_VALUE)
        );

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        jComboBoxBackgroundColor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BLACK", "BLUE", "CYAN", "DARK_GRAY", "GRAY", "GREEN", "LIGHT_GRAY", "MAGENTA", "ORANGE", "PINK", "RED", "WHITE", "YELLOW" }));
        jComboBoxBackgroundColor.setName("jComboBoxBackgroundColor"); // NOI18N
        jComboBoxBackgroundColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxBackgroundColorActionPerformed(evt);
            }
        });

        jPanelBackgroundColor.setBackground(resourceMap.getColor("jPanelBackgroundColor.background")); // NOI18N
        jPanelBackgroundColor.setName("jPanelBackgroundColor"); // NOI18N

        javax.swing.GroupLayout jPanelBackgroundColorLayout = new javax.swing.GroupLayout(jPanelBackgroundColor);
        jPanelBackgroundColor.setLayout(jPanelBackgroundColorLayout);
        jPanelBackgroundColorLayout.setHorizontalGroup(
            jPanelBackgroundColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 35, Short.MAX_VALUE)
        );
        jPanelBackgroundColorLayout.setVerticalGroup(
            jPanelBackgroundColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 27, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jComboBoxAxesColor, 0, 206, Short.MAX_VALUE)
                    .addComponent(jComboBoxGridColor, 0, 206, Short.MAX_VALUE)
                    .addComponent(jComboBoxBackgroundColor, 0, 206, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelAxesColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanelGridColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanelBackgroundColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(104, 104, 104))
        );

        jPanel1Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel3, jLabel4});

        jPanel1Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jPanelAxesColor, jPanelGridColor});

        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jPanelAxesColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanelGridColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanelBackgroundColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                            .addComponent(jComboBoxAxesColor, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(jComboBoxGridColor, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(15, 15, 15)
                            .addComponent(jComboBoxBackgroundColor, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel1Layout.createSequentialGroup()
                            .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(15, 15, 15)
                            .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel1Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jComboBoxAxesColor, jComboBoxGridColor, jLabel3, jLabel4, jPanelAxesColor, jPanelGridColor});

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel2.border.title"))); // NOI18N
        jPanel2.setName("jPanel2"); // NOI18N

        jCheckBoxAxes.setText(resourceMap.getString("jCheckBoxAxes.text")); // NOI18N
        jCheckBoxAxes.setName("jCheckBoxAxes"); // NOI18N

        jCheckBoxGrid.setText(resourceMap.getString("jCheckBoxGrid.text")); // NOI18N
        jCheckBoxGrid.setName("jCheckBoxGrid"); // NOI18N

        jCheckBoxTickLabels.setText(resourceMap.getString("jCheckBoxTickLabels.text")); // NOI18N
        jCheckBoxTickLabels.setEnabled(false);
        jCheckBoxTickLabels.setName("jCheckBoxTickLabels"); // NOI18N

        jCheckBoxDrawLabels.setText(resourceMap.getString("jCheckBoxDrawLabels.text")); // NOI18N
        jCheckBoxDrawLabels.setEnabled(false);
        jCheckBoxDrawLabels.setName("jCheckBoxDrawLabels"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBoxTickLabels)
                    .addComponent(jCheckBoxGrid)
                    .addComponent(jCheckBoxAxes)
                    .addComponent(jCheckBoxDrawLabels))
                .addContainerGap(26, Short.MAX_VALUE))
        );

        jPanel2Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jCheckBoxAxes, jCheckBoxDrawLabels, jCheckBoxGrid, jCheckBoxTickLabels});

        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBoxAxes)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBoxGrid)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBoxTickLabels)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBoxDrawLabels)
                .addContainerGap(24, Short.MAX_VALUE))
        );

        jPanel2Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jCheckBoxAxes, jCheckBoxDrawLabels, jCheckBoxGrid, jCheckBoxTickLabels});

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanelScale, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jButtonOK)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonFitZoom)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonFitTick)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonCancel)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jButtonFitTick, jButtonFitZoom});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelScale, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(8, 8, 8)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(15, 15, 15)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonCancel)
                    .addComponent(jButtonFitTick)
                    .addComponent(jButtonFitZoom)
                    .addComponent(jButtonOK))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jButtonFitTick, jButtonFitZoom});

        pack();
    }// </editor-fold>//GEN-END:initComponents


    private void jButtonFitZoomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFitZoomActionPerformed
        LinkedList<Drawing> drawings = ((ConsoleEngCalculatorDrawBox) getParent()).getDrawings();
        if (drawings.size() == 0) return;

        double xmin=0, xmax=0, ymin=0, ymax=0, cmin=0, cmax=0;
        boolean firstXRun = true, firstYRun = true, firstCRun = true;
        IntervalList data;
        Interval i;
        int columns, j;
        for (Drawing d : drawings) {
            if (! d.isVisible()) continue;

            data = d.getData().getValue();
            columns = data.getColumns();

            for (j=0;j<data.size();j+=columns) {
                try {
                    i = data.get(j);
                    if (i.isProper()) {
                        if (firstXRun || xmin > i.getLeft()) xmin = i.getLeft();
                        if (firstXRun || xmax < i.getRight()) xmax = i.getRight();
                        if (firstXRun) firstXRun = false;
                    }
                    i = data.get(j+1);
                    if (i.isProper()) {
                        if (firstYRun || ymin > i.getLeft()) ymin=i.getLeft();
                        if (firstYRun || ymax < i.getRight()) ymax = i.getRight();
                        if (firstYRun) firstYRun = false;
                    }
                    i = data.get(j+2);
                    if (i.isProper() && columns > 2) {
                        if (ConsoleEngCalculatorDrawBox.isColorSetByVal(d.getColorIndex())) {
                            double val = i.getVal();
                            if (firstCRun || cmin > val) cmin = val;
                            if (firstCRun || cmax < val) cmax = val;
                            if (firstCRun) firstCRun = false;
                        } else if (ConsoleEngCalculatorDrawBox.isColorSetByTol(d.getColorIndex())) {
                            double tol = i.getTol();
                            if (firstCRun || cmin > tol) cmin = tol;
                            if (firstCRun || cmax < tol) cmax = tol;
                            if (firstCRun) firstCRun = false;
                        }
                    }
                } catch (Exception ex) {
                    //skip
                }
            }
        }

        jTextFieldXMax.setText(decimalFormat.format(xmax));
        jTextFieldXMin.setText(decimalFormat.format(xmin));
        jTextFieldYMax.setText(decimalFormat.format(ymax));
        jTextFieldYMin.setText(decimalFormat.format(ymin));
        jTextFieldCMax.setText(decimalFormat.format(cmax));
        jTextFieldCMin.setText(decimalFormat.format(cmin));

    }//GEN-LAST:event_jButtonFitZoomActionPerformed

    private void jButtonFitTickActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFitTickActionPerformed
        jTextFieldXTick.setText(decimalFormat.format(Math.ceil((Float.parseFloat(jTextFieldXMax.getText())-Float.parseFloat(jTextFieldXMin.getText()))/5)));
        jTextFieldYTick.setText(decimalFormat.format(Math.ceil((Float.parseFloat(jTextFieldYMax.getText())-Float.parseFloat(jTextFieldYMin.getText()))/5)));
    }//GEN-LAST:event_jButtonFitTickActionPerformed

    private void jComboBoxAxesColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxAxesColorActionPerformed
        jPanelAxesColor.setBackground(ConsoleEngCalculatorDrawBox.colorConverter(jComboBoxAxesColor.getSelectedIndex()));
}//GEN-LAST:event_jComboBoxAxesColorActionPerformed

    private void jComboBoxGridColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxGridColorActionPerformed
        jPanelGridColor.setBackground(ConsoleEngCalculatorDrawBox.colorConverter(jComboBoxGridColor.getSelectedIndex()));
    }//GEN-LAST:event_jComboBoxGridColorActionPerformed

    private void jComboBoxBackgroundColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxBackgroundColorActionPerformed
        jPanelBackgroundColor.setBackground(ConsoleEngCalculatorDrawBox.colorConverter(jComboBoxBackgroundColor.getSelectedIndex()));
    }//GEN-LAST:event_jComboBoxBackgroundColorActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        setVisible(false);
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        storeDataOnCanvas ();
        jButtonCancelActionPerformed(null);
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
        CartesianPlane cp = ((ConsoleEngCalculatorDrawBox) getParent()).getFunctionDrawer().getCartesianPlane();
        jTextFieldXMax.setText(decimalFormat.format(cp.getXMax()));
        jTextFieldXMin.setText(decimalFormat.format(cp.getXMin()));
        jTextFieldYMax.setText(decimalFormat.format(cp.getYMax()));
        jTextFieldYMin.setText(decimalFormat.format(cp.getYMin()));
        jTextFieldCMax.setText(decimalFormat.format(cp.getCMax()));
        jTextFieldCMin.setText(decimalFormat.format(cp.getCMin()));
        jTextFieldXTick.setText(decimalFormat.format(cp.getXTick()));
        jTextFieldYTick.setText(decimalFormat.format(cp.getYTick()));
        jCheckBoxAxes.setSelected(cp.isShowAxes());
        jCheckBoxGrid.setSelected(cp.isShowGrid());
        jCheckBoxDrawLabels.setSelected(cp.isShowDrawLabels());
        jCheckBoxTickLabels.setSelected(cp.isShowTickLabels());
        jComboBoxAxesColor.setSelectedIndex(cp.getAxesCI());
        jComboBoxBackgroundColor.setSelectedIndex(cp.getBackgroundCI());
        jComboBoxGridColor.setSelectedIndex(cp.getGridCI());
    }//GEN-LAST:event_formWindowGainedFocus

    public void storeDataOnCanvas () {
        ((ConsoleEngCalculatorDrawBox) getParent()).getFunctionDrawer().setCartesianPlane(new CartesianPlane(Double.parseDouble(jTextFieldXMin.getText()), Double.parseDouble(jTextFieldXMax.getText()), Double.parseDouble(jTextFieldYMin.getText()), Double.parseDouble(jTextFieldYMax.getText()), Double.parseDouble(jTextFieldCMin.getText()), Double.parseDouble(jTextFieldCMax.getText()), Double.parseDouble(jTextFieldXTick.getText()), Double.parseDouble(jTextFieldYTick.getText()), jCheckBoxAxes.isSelected(), jCheckBoxGrid.isSelected(), jCheckBoxTickLabels.isSelected(), jCheckBoxDrawLabels.isSelected(), jComboBoxBackgroundColor.getSelectedIndex(), jComboBoxAxesColor.getSelectedIndex(), jComboBoxGridColor.getSelectedIndex()));
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonFitTick;
    private javax.swing.JButton jButtonFitZoom;
    private javax.swing.JButton jButtonOK;
    private javax.swing.JCheckBox jCheckBoxAxes;
    private javax.swing.JCheckBox jCheckBoxDrawLabels;
    private javax.swing.JCheckBox jCheckBoxGrid;
    private javax.swing.JCheckBox jCheckBoxTickLabels;
    private javax.swing.JComboBox jComboBoxAxesColor;
    private javax.swing.JComboBox jComboBoxBackgroundColor;
    private javax.swing.JComboBox jComboBoxGridColor;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanelAxesColor;
    private javax.swing.JPanel jPanelBackgroundColor;
    private javax.swing.JPanel jPanelGridColor;
    private javax.swing.JPanel jPanelScale;
    private javax.swing.JTextField jTextFieldCMax;
    private javax.swing.JTextField jTextFieldCMin;
    private javax.swing.JTextField jTextFieldXMax;
    private javax.swing.JTextField jTextFieldXMin;
    private javax.swing.JTextField jTextFieldXTick;
    private javax.swing.JTextField jTextFieldYMax;
    private javax.swing.JTextField jTextFieldYMin;
    private javax.swing.JTextField jTextFieldYTick;
    // End of variables declaration//GEN-END:variables
    
}
