/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.function.infix.InfixFunction;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class InfixFunctionTkn extends Token {
    public static final String OPERATORS = "+-*/^=,<>!&|:_%#";

    private InfixFunction infixFunction;
    private PrefixFunction prefixFunction;

    public InfixFunctionTkn() {}

    protected InfixFunctionTkn(String function, InfixFunction infixFunction, PrefixFunction prefixFunction) {
        super (function);
        this.infixFunction = infixFunction;
        this.prefixFunction = prefixFunction;
    }

    @Override
    public InfixFunction getInfixFunction () {
        return infixFunction;
    }

    @Override
    public PrefixFunction getPrefixFunction () {//that is important for operators used as unary one like minus
        return prefixFunction;
    }
    @Override
    public Token generateToken(String symbol) {
        InfixFunction ifun = InfixFunction.getFunction (symbol);
        PrefixFunction pfun = PrefixFunction.getFunction (symbol);
        if (ifun != null) return new InfixFunctionTkn(symbol, ifun, pfun);
        return null;

    }

    @Override
    public boolean mayBeCompatible(String symbol) {
        for (Character c : symbol.toCharArray())
            if (OPERATORS.indexOf(c) == -1) return false;
        return true;
    }
}
