/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.variable.Variable;

/**
 *
 * @author simone
 */
public class VariableTkn extends Token {
    private final static PrefixFunctionTkn PREFIX_FUNCTION_TKN = new PrefixFunctionTkn ();

    private Variable variable;
    private boolean earlyBinding;

    public VariableTkn() {}

    private VariableTkn(String name, Variable variable, boolean earlyBinding) {
        super (name);
        this.variable = variable;
        this.earlyBinding = earlyBinding;
    }

    @Override
    public IntervalList getIntervalList() throws CalculusException {   
        Variable v = variable;
        if (! earlyBinding) v = Variable.getVariable(getSymbol());
        if (v == null) throw new CalculusException ("It is not possible to find any longer the required variable");
        return v.getValue();                                                   //early binding
    }

    @Override
    public Token generateToken(String symbol) {
        Variable v = Variable.getVariable(symbol);
        if (v != null) {
            return new VariableTkn (symbol, v, isDefiningFunction() || v.isConstant());
        }
        return null;
    }

    @Override
    public boolean mayBeCompatible(String symbol) {
        return PREFIX_FUNCTION_TKN.mayBeCompatible(symbol);
    }

    @Override
    public boolean isVariable() {
        return true;
    }
    
}
