/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.list;

import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.infix.InfixFunction;

/**
 *
 * @author simone
 */
public class ListBuilder extends InfixFunction {
    private final static String[] EXAMPLE_LEFT = {"6_7", "1_2,3_4", "(1,2)#1"};
    private final static String[] EXAMPLE_RIGHT = {"4_5", "5_6", "(3,4)#1"};
    private final static String[] RESULT = {"6_7,4_5", "1_2, 3_4, 5_6", "(1,3,2,4)#2"};

    public ListBuilder() {
        super (",", (byte) -1, (byte) -1, false, true, "Separate intervals to get a list of intervals or joins two matrix.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList left, IntervalList right) throws Exception {        
        IntervalList result = null;

        if (left.isMatrix() && right.isMatrix()) {
            final int rl = left.getRows(), cl=left.getColumns();
            final int rr = right.getRows(), cr = right.getColumns();

            if (cl == cr && (rl != rr || rl == 1)) {//in the expression on the left if rl==1 then rr == 1
                result = new MatrixIntervalList (cl);
                result.addAll(left);
                result.addAll(right);
                return result;
            }

            if (rl == rr) {
                result = new MatrixIntervalList(cl+cr);
                for (int i=0; i<rl; ++i) {
                    for (int j=0; j<cl; ++j) result.append(left.get(i, j));
                    for (int j=0; j<cr; ++j) result.append(right.get(i, j));
                }
                return result;
            }
        }

        result = new IntervalList();
        result.addAll(left);
        result.addAll(right);
        return result;
    }
}
