/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.matrix;

import engcalculator.function.infix.arithmetic.Sum;
import engcalculator.function.infix.arithmetic.Mul;
import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.InfixFunction;

/**
 *
 * @author simone
 */
public class MatrixMul extends InfixFunction {
    private final static String[] EXAMPLE_LEFT = {"(1,2,3,4)#2"};
    private final static String[] EXAMPLE_RIGHT = {"(5,6,7,8)#2"};
    private final static String[] RESULT = {"(19,22,43,50)#2"};
    private final static Mul MUL = new Mul();
    private final static Sum SUM = new Sum();

    public MatrixMul() {
        super ("**", (byte) -1, (byte)  -1, false, true, "a ** b multiply the matrix a for the matrix b row by columns as per Kaucher arithmetic. ", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList leftSide, IntervalList rightSide) throws Exception {        
        if (! leftSide.isProperMatrix() || ! rightSide.isProperMatrix()) throw new CalculusException ("The input matrixes are not complete.");
        if (leftSide.getColumns() != rightSide.getRows()) throw new CalculusException ("The matrixes column and rows do not match for multiplication.");
        final int leftRow = leftSide.getRows(), rightCol = rightSide.getColumns(), size = leftSide.getColumns();
//        final MatrixIntervalList leftMatrix = (MatrixIntervalList) leftSide, rightMatrix = (MatrixIntervalList) rightSide;
        IntervalList result = new MatrixIntervalList ((byte) rightCol);
        Interval accumulator;
        int r, c, i;

        for (r = 0; r < leftRow; ++r) {            
            for (c = 0; c < rightCol; ++ c) {
                accumulator = new Interval(0);
                for (i = 0; i < size ; ++ i) {
                    accumulator = SUM._computeIntervals(accumulator, MUL._computeIntervals(leftSide.get(r, i), rightSide.get(i, c)));
                }
                result.add(accumulator);
            }            
        }

        return result;
    }
}
