/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix;

import engcalculator.function.prefix.PrefixFunction;
import engcalculator.data.IntervalList;

/**
 *
 * @author simone
 */
public abstract class PrefixFunctionExpandsLast extends PrefixFunction {

    public PrefixFunctionExpandsLast(String name, byte numbArgs, boolean expandsToLists, boolean constant, String help, String[] examples, String[] results) {
        super(name, numbArgs, expandsToLists, constant, "It is possible to apply this function to multiple arguments just adding several intervals as last parameter. "+help, examples, results);
    }

    @Override
    public IntervalList compute(IntervalList... inputArray) throws Exception {
        if (inputArray.length != getNumberOfArguments()) throw new Exception ("It was expected just one argument for a prefix function");
        IntervalList input = inputArray[0];

        IntervalList result = new IntervalList ();

        int i = getNumbArgs()-1;
        IntervalList argument, fixArgument = input.subList(0, i);
        while (i < input.size()) {
            argument = new IntervalList(fixArgument);
            argument.add(input.get(i));
            result.addAll(super.compute(argument));
            ++i;
        }
        return result;
    }



}
