/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.calculus;

import engcalculator.function.prefix.PrefixFunctionExpandsLast;
import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.arithmetic.Div;
import engcalculator.function.infix.arithmetic.Sub;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class Derivate extends PrefixFunctionExpandsLast {
    private final static Sub SUB = new Sub();
    private final static Div DIV = new Div();

    private final static String[] EXAMPLE = {"'sin', -0.0001_0.0001"};
    private final static String[] RESULT = {"1"};

    public Derivate() {
        super("derivate", (byte) 2, false, true, "derivate ('f', x0) compute the incremental ratio of the function f in the point x0.", EXAMPLE, RESULT);
    }
    

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        PrefixFunction f = PrefixFunction.getFunction(input.getFirst().getName());
        if (f == null) throw new CalculusException ("It is not possible to find the function to derivate");
        if (f.getNumbArgs() != 1) throw new CalculusException ("It is required a function of 1 argument to be derivated");
        Interval x = input.get(1);
        IntervalList x1, x0;
        x1 = new IntervalList ( new Interval (x.getRight()));
        x0 = new IntervalList ( new Interval (x.getLeft()));
        return DIV._compute (SUB._compute(f.compute(x1), f.compute(x0)),new IntervalList(new Interval(x.getRange())));
    }

}
