/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.calculus;

import engcalculator.function.prefix.PrefixFunctionExpandsLast;
import engcalculator.function.prefix.cumulative.SumUp;
import engcalculator.function.prefix.space.LinSpace;
import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.arithmetic.Mul;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class Integrate extends PrefixFunctionExpandsLast {
    private static final SumUp SUM_UP = new SumUp();
    private static final Mul MUL = new Mul();
    private static final LinSpace LIN_SPACE = new LinSpace();

    private final static String[] EXAMPLE = {"'sin', 100, 0_pi"};
    private final static String[] RESULT = {"2"};

    public Integrate() {
        super("integrate", (byte) 3, true, true, "integrate ('f', nofpoints, interval) integrate the function f in the given interval splitting the interval in the given number of points. The interval is splitted in the given number of intervals and the rectangulars areas are computed and summed.", EXAMPLE, RESULT);
    }


    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        Interval range = input.get(2), noi = input.get(1);
        IntervalList space = LIN_SPACE._compute(new IntervalList (new Interval(2*(int) noi.getLeft()-1)).append(range));
        final double delta = (range.getRight()-range.getLeft())/((int) noi.getLeft()-1);
        for (int i=space.size()-1;i>=0;i -= 2) space.remove(i);
//        space.removeLast();//that is important to avoid to compute a rectangle more
        PrefixFunction f = PrefixFunction.getFunction(input.getFirst().getName());
        if (f == null || f.getNumbArgs() != 1) throw new CalculusException ("It is required a prefix function of 1 argument to be integrated");
        return SUM_UP._compute(MUL.compute(new IntervalList( new Interval (delta)), f.compute(space)));
    }

}
