/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.engineering;

import engcalculator.data.IntervalList;
import engcalculator.data.Literal;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class ToColorCode extends PrefixFunction {
//    Example cannot be used because the function does not provide a numerica result

    private final static String[] COLORS = {"black", "brown", "red", "orange", "yellow", "green", "blue", "violet", "gray", "white", "gold", "silver", "none"};
    private final static float[] TOLERANCE = {-1, 1, 2, -1, -1, 0.5f, 0.25f, 0.1f, 0.05f, -1, 5, 10, 20};

    public ToColorCode() {
        super ("tocolor", (byte) 1, true, true, "Convert the given value to a color code, use preferred function to be sure the color code does exists commercially. For example: tocolor(100K%10)=('brown','black','yellow','silver').", null, null);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        final int digits;
        double tol = input.getFirst().getTol();
        
        if (tol > 3.5) digits = 2;
        else digits = 3;
        if (tol < 0) throw new CalculusException ("Value out of range.");
        
        double val = input.getFirst().getVal();
        final double max = Math.pow(10, digits);
        final double min = Math.pow(10, digits-1);
        
        int exp = 0;
        while (val >= max) {
            val /= 10;
            ++exp;
        }
        while (val < min) {
            val *= 10;
            --exp;
        }
        
        if (exp > 9 || exp < 0) throw new CalculusException ("Value out of range.");
        
        String sVal = Integer.toString((int) val);
        IntervalList result = new IntervalList();
        for (int i=0;i<digits;++i) 
            result.append(new Literal(COLORS[sVal.charAt(i)-'0']));
        
        result.append(new Literal(COLORS[(int) exp]));
        
        result.append(new Literal(COLORS[findCloserIndex(TOLERANCE, (float) tol, false)]));
        
        return result;

    }

}
