/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.plot;

import engcalculator.data.Interval;
import engcalculator.function.prefix.space.LinSpace;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.interval.IntervalByToleranceBuilder;

/**
 *
 * @author simone
 */
public class StandardPlot extends PrefixFunction {
    private final static String[] EXAMPLE = {"'sin', 5, 0_2*pi, 0"};
    private final static String[] RESULT = {"((0,pi/2,pi,3*pi/2,2*pi)#1 ,| (0,1,0,-1,0)#1)"};
    private final static LinSpace LIN_SPACE = new LinSpace();
    private final static IntervalByToleranceBuilder INTERVAL_BY_TOLERANCE_BUILDER = new IntervalByToleranceBuilder();

    public StandardPlot () {
        super("standardplot", (byte) 4, false, false, "standardplot build an array which can later be used to plot the function. It requires the function name to compute the y, the number of points, the interval range and the tolerance of those intervals constituing x.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        String fname = input.getFirst().getName();
        if (fname == null) throw new CalculusException ("It is expected a function name as first element");
        PrefixFunction f = PrefixFunction.getFunction(fname);
        if (f == null) throw new CalculusException ("It is not possible to find a function matching the given name");
        if (f.getNumbArgs() != 1) throw new CalculusException ("It is required a function of 1 argument");

        IntervalList x = new MatrixIntervalList(INTERVAL_BY_TOLERANCE_BUILDER.compute(LIN_SPACE._compute(input.subList(1, 3)), new IntervalList(input.get(3))), 1);
        
        //it is not used the property of function to work on list in order to skip the 'bad' values
        MatrixIntervalList result = new MatrixIntervalList (2);
        final int s = x.size();
        for (int i=0; i<s; ++i) {
            Interval y;
            try {
                y = f._compute(x.subList(i, i+1)).getFirst(); //y need to be computed before to skip the step on exception
                result.add(x.get(i));
                result.add(y);
            } catch (Exception ce) {
            }
        }

        return result;
    }

}
