/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.trigonometry;


import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;
import engcalculator.function.infix.set.SuperSet;
import engcalculator.function.prefix.interval.Dual;

/**
 *
 * @author simone
 */
public abstract class Trig extends SingleInputSingleOutputPrefixFunction {
    private final static SuperSet SUPERSET = new SuperSet();
    private final static Dual DUAL = new Dual();
    private double absoluteMin, absoluteMinPoint, absoluteMax, absoluteMaxPoint, range;

    public Trig(String name, String help, double absoluteMin, double absoluteMinPoint, double absoluteMax, double absoluteMaxPoint, double rangeMin, double rangeMax, String[] examples, String[] results) {
        super (name, true,true, help, examples, results);
        this.absoluteMin = absoluteMin;
        this.absoluteMinPoint = absoluteMinPoint;
        this.absoluteMax = absoluteMax;
        this.absoluteMaxPoint = absoluteMaxPoint;

        range = rangeMax-rangeMin;
    }

    @Override
    public final Interval _computeIntervals(Interval input) throws Exception {
        Interval result = null;

        if (input.getRange() >= range) result = new Interval(absoluteMin, absoluteMax);
        else {
            double displacedMinPoint = Math.floor(input.getLeft()/range)*range+absoluteMinPoint;
            double displacedMaxPoint = Math.floor(input.getRight()/range)*range+absoluteMaxPoint;

            double vmin, vmax, min, max;
            vmin = __compute(input.getLeft());
            vmax = __compute(input.getRight());

            max = Math.max(vmin, vmax);
            min = Math.min(vmin, vmax);

            if (SUPERSET.compare(input, new Interval(displacedMaxPoint))) max = absoluteMax;
            if (SUPERSET.compare(input, new Interval(displacedMinPoint))) min = absoluteMin;

            result = new Interval (min, max).setOuter();
        }

        if (! input.isProper()) return DUAL._computeIntervals(result);
        else return result;
    }

    protected abstract double __compute (double input) ;

}
